Index: external/fastjet/internal/LazyTiling9.hh
===================================================================
--- external/fastjet/internal/LazyTiling9.hh	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
+++ external/fastjet/internal/LazyTiling9.hh	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
@@ -0,0 +1,240 @@
+#ifndef __FASTJET_LAZYTILING9_HH__
+#define __FASTJET_LAZYTILING9_HH__
+
+//#define INSTRUMENT2 1
+
+//FJSTARTHEADER
+// $Id: LazyTiling9.hh 3477 2014-07-29 14:34:39Z salam $
+//
+// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+//
+//----------------------------------------------------------------------
+// This file is part of FastJet.
+//
+//  FastJet is free software; you can redistribute it and/or modify
+//  it under the terms of the GNU General Public License as published by
+//  the Free Software Foundation; either version 2 of the License, or
+//  (at your option) any later version.
+//
+//  The algorithms that underlie FastJet have required considerable
+//  development. They are described in the original FastJet paper,
+//  hep-ph/0512210 and in the manual, arXiv:1111.6097. If you use
+//  FastJet as part of work towards a scientific publication, please
+//  quote the version you use and include a citation to the manual and
+//  optionally also to hep-ph/0512210.
+//
+//  FastJet is distributed in the hope that it will be useful,
+//  but WITHOUT ANY WARRANTY; without even the implied warranty of
+//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+//  GNU General Public License for more details.
+//
+//  You should have received a copy of the GNU General Public License
+//  along with FastJet. If not, see <http://www.gnu.org/licenses/>.
+//----------------------------------------------------------------------
+//FJENDHEADER
+
+//#include "fastjet/PseudoJet.hh"
+#include "fastjet/internal/MinHeap.hh"
+#include "fastjet/ClusterSequence.hh"
+#include "fastjet/internal/LazyTiling9Alt.hh"
+
+
+FASTJET_BEGIN_NAMESPACE      // defined in fastjet/internal/base.hh
+template<int NN>
+class Tile2Base {
+public:
+  /// pointers to neighbouring tiles, including self
+  Tile2Base *   begin_tiles[NN]; 
+  /// neighbouring tiles, excluding self
+  Tile2Base **  surrounding_tiles; 
+  /// half of neighbouring tiles, no self
+  Tile2Base **  RH_tiles;  
+  /// just beyond end of tiles
+  Tile2Base **  end_tiles; 
+  /// start of list of BriefJets contained in this tile
+  TiledJet * head;    
+  /// sometimes useful to be able to tag a tile
+  bool     tagged;    
+  /// true for tiles where the delta phi calculation needs
+  /// potentially to account for periodicity in phi
+  bool     use_periodic_delta_phi;
+  /// for all particles in the tile, this stores the largest of the
+  /// (squared) nearest-neighbour distances.
+  double max_NN_dist;
+  double eta_centre, phi_centre;
+
+  /// returns the number of jets in the tile; useful principally for
+  /// diagnostics
+  int jet_count() const {
+    int count = 0;
+    const TiledJet * jet = head;
+    while (jet != 0) {
+      count++;
+      jet = jet->next;
+    }
+    return count;
+  }
+};
+
+
+typedef Tile2Base<9> Tile2;
+
+// class Tile2 : public Tile2Base {
+// public:
+//   /// pointers to neighbouring tiles, including self
+//   Tile2 *   begin_tiles[n_tile_neighbours]; 
+//   bool is_near_zero_phi(double tile_size_phi) const {
+//     return phi_centre < tile_size_phi || (twopi-phi_centre) < tile_size_phi;
+//   }
+// };
+
+// class Tile2  {
+// public:
+//   /// pointers to neighbouring tiles, including self
+//   Tile2 *   begin_tiles[n_tile_neighbours]; 
+//   /// neighbouring tiles, excluding self
+//   Tile2 **  surrounding_tiles; 
+//   /// half of neighbouring tiles, no self
+//   Tile2 **  RH_tiles;  
+//   /// just beyond end of tiles
+//   Tile2 **  end_tiles; 
+//   /// start of list of BriefJets contained in this tile
+//   TiledJet * head;    
+//   /// sometimes useful to be able to tag a tile
+//   bool     tagged;    
+//   /// for all particles in the tile, this stores the largest of the
+//   /// (squared) nearest-neighbour distances.
+//   double max_NN_dist;
+//   double eta_centre, phi_centre;
+//   bool is_near_zero_phi(double tile_size_phi) const {
+//     return phi_centre < tile_size_phi || (twopi-phi_centre) < tile_size_phi;
+//   }
+// };
+
+
+
+//----------------------------------------------------------------------
+class LazyTiling9 {
+public:
+  LazyTiling9(ClusterSequence & cs);
+
+  void run();
+
+  //void get_next_clustering(int & jetA_index, int & jetB_index, double & dij);
+  
+
+protected:
+  ClusterSequence & _cs;
+  const std::vector<PseudoJet> & _jets;
+  std::vector<Tile2> _tiles;
+
+#ifdef INSTRUMENT2
+  int _ncall; // GPS tmp
+  int _ncall_dtt; // GPS tmp
+#endif // INSTRUMENT2
+
+  double _Rparam, _R2, _invR2;
+  double _tiles_eta_min, _tiles_eta_max;
+  double _tile_size_eta, _tile_size_phi;
+  double _tile_half_size_eta, _tile_half_size_phi;
+  int    _n_tiles_phi,_tiles_ieta_min,_tiles_ieta_max;
+
+  std::vector<TiledJet *> _jets_for_minheap;
+  
+  //MinHeap _minheap;
+
+  void _initialise_tiles();
+
+  // reasonably robust return of tile index given ieta and iphi, in particular
+  // it works even if iphi is negative
+  inline int _tile_index (int ieta, int iphi) const {
+    // note that (-1)%n = -1 so that we have to add _n_tiles_phi
+    // before performing modulo operation
+    return (ieta-_tiles_ieta_min)*_n_tiles_phi
+                  + (iphi+_n_tiles_phi) % _n_tiles_phi;
+  }
+
+  void  _bj_remove_from_tiles(TiledJet * const jet);
+
+  /// returns the tile index given the eta and phi values of a jet
+  int _tile_index(const double eta, const double phi) const;
+
+  // sets up information regarding the tiling of the given jet
+  void _tj_set_jetinfo(TiledJet * const jet, const int _jets_index);
+
+  void _print_tiles(TiledJet * briefjets ) const;
+  void _add_neighbours_to_tile_union(const int tile_index, 
+		 std::vector<int> & tile_union, int & n_near_tiles) const;
+  void _add_untagged_neighbours_to_tile_union(const int tile_index, 
+		 std::vector<int> & tile_union, int & n_near_tiles);
+  void _add_untagged_neighbours_to_tile_union_using_max_info(const TiledJet * const jet, 
+		 std::vector<int> & tile_union, int & n_near_tiles);
+  double _distance_to_tile(const TiledJet * bj, const Tile2 *) 
+#ifdef INSTRUMENT2
+    ;
+#else
+    const;
+#endif 
+  void _update_jetX_jetI_NN(TiledJet * jetX, TiledJet * jetI, std::vector<TiledJet *> & jets_for_minheap);
+
+  void _set_NN(TiledJet * jetI, std::vector<TiledJet *> & jets_for_minheap);
+
+  // return the diJ (multiplied by _R2) for this jet assuming its NN
+  // info is correct
+  template <class J> double _bj_diJ(const J * const jet) const {
+    double kt2 = jet->kt2;
+    if (jet->NN != NULL) {if (jet->NN->kt2 < kt2) {kt2 = jet->NN->kt2;}}
+    return jet->NN_dist * kt2;
+  }
+
+
+  //----------------------------------------------------------------------
+  template <class J> inline void _bj_set_jetinfo(
+                            J * const jetA, const int _jets_index) const {
+    jetA->eta  = _jets[_jets_index].rap();
+    jetA->phi  = _jets[_jets_index].phi_02pi();
+    jetA->kt2  = _cs.jet_scale_for_algorithm(_jets[_jets_index]);
+    jetA->_jets_index = _jets_index;
+    // initialise NN info as well
+    jetA->NN_dist = _R2;
+    jetA->NN      = NULL;
+  }
+
+
+  //----------------------------------------------------------------------
+  template <class J> inline double _bj_dist(
+                const J * const jetA, const J * const jetB) 
+#ifdef INSTRUMENT2
+    {
+    _ncall++; // GPS tmp
+#else
+    const {
+#endif 
+    double dphi = std::abs(jetA->phi - jetB->phi);
+    double deta = (jetA->eta - jetB->eta);
+    if (dphi > pi) {dphi = twopi - dphi;}
+    return dphi*dphi + deta*deta;
+  }
+
+
+  //----------------------------------------------------------------------
+  template <class J> inline double _bj_dist_not_periodic(
+                const J * const jetA, const J * const jetB)
+#ifdef INSTRUMENT2
+    {
+    _ncall++; // GPS tmp
+#else
+    const {
+#endif 
+    //_ncall++; // GPS tmp
+    double dphi = jetA->phi - jetB->phi;
+    double deta = (jetA->eta - jetB->eta);
+    return dphi*dphi + deta*deta;
+  }
+
+};
+
+
+FASTJET_END_NAMESPACE
+
+#endif // __FASTJET_LAZYTILING9_HH__
Index: external/fastjet/internal/LazyTiling9Alt.hh
===================================================================
--- external/fastjet/internal/LazyTiling9Alt.hh	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
+++ external/fastjet/internal/LazyTiling9Alt.hh	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
@@ -0,0 +1,226 @@
+#ifndef __FASTJET_LAZYTILING9ALT_HH__
+#define __FASTJET_LAZYTILING9ALT_HH__
+
+//FJSTARTHEADER
+// $Id: LazyTiling9Alt.hh 3477 2014-07-29 14:34:39Z salam $
+//
+// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+//
+//----------------------------------------------------------------------
+// This file is part of FastJet.
+//
+//  FastJet is free software; you can redistribute it and/or modify
+//  it under the terms of the GNU General Public License as published by
+//  the Free Software Foundation; either version 2 of the License, or
+//  (at your option) any later version.
+//
+//  The algorithms that underlie FastJet have required considerable
+//  development. They are described in the original FastJet paper,
+//  hep-ph/0512210 and in the manual, arXiv:1111.6097. If you use
+//  FastJet as part of work towards a scientific publication, please
+//  quote the version you use and include a citation to the manual and
+//  optionally also to hep-ph/0512210.
+//
+//  FastJet is distributed in the hope that it will be useful,
+//  but WITHOUT ANY WARRANTY; without even the implied warranty of
+//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+//  GNU General Public License for more details.
+//
+//  You should have received a copy of the GNU General Public License
+//  along with FastJet. If not, see <http://www.gnu.org/licenses/>.
+//----------------------------------------------------------------------
+//FJENDHEADER
+
+//#include "fastjet/PseudoJet.hh"
+#include "fastjet/internal/MinHeap.hh"
+#include "fastjet/ClusterSequence.hh"
+
+FASTJET_BEGIN_NAMESPACE      // defined in fastjet/internal/base.hh
+
+/// structure analogous to BriefJet, but with the extra information
+/// needed for dealing with tiles
+class TiledJet {
+public:
+  double     eta, phi, kt2, NN_dist;
+  TiledJet * NN, *previous, * next; 
+  int        _jets_index, tile_index;
+  bool _minheap_update_needed;
+
+  // indicate whether jets need to have their minheap entries
+  // updated).
+  inline void label_minheap_update_needed() {_minheap_update_needed = true;}
+  inline void label_minheap_update_done()   {_minheap_update_needed = false;}
+  inline bool minheap_update_needed() const {return _minheap_update_needed;}
+};
+
+const int n_tile_neighbours = 9;
+
+class Tile {
+public:
+  typedef double (Tile::*DistToTileFn)(const TiledJet*) const;
+  typedef std::pair<Tile *, DistToTileFn> TileFnPair;
+  /// pointers to neighbouring tiles, including self
+  TileFnPair begin_tiles[n_tile_neighbours]; 
+  /// neighbouring tiles, excluding self
+  TileFnPair *  surrounding_tiles; 
+  /// half of neighbouring tiles, no self
+  TileFnPair *  RH_tiles;  
+  /// just beyond end of tiles
+  TileFnPair *  end_tiles; 
+  /// start of list of BriefJets contained in this tile
+  TiledJet * head;    
+  /// sometimes useful to be able to tag a tile
+  bool     tagged;    
+  /// true for tiles where the delta phi calculation needs
+  /// potentially to account for periodicity in phi
+  bool     use_periodic_delta_phi;
+  /// for all particles in the tile, this stores the largest of the
+  /// (squared) nearest-neighbour distances.
+  double max_NN_dist;
+  double eta_min, eta_max, phi_min, phi_max;
+
+  double distance_to_centre(const TiledJet *) const {return 0;}
+  double distance_to_left(const TiledJet * jet) const {
+    double deta = jet->eta - eta_min;
+    return deta*deta;
+  }
+  double distance_to_right(const TiledJet * jet) const {
+    double deta = jet->eta - eta_max;
+    return deta*deta;
+  }
+  double distance_to_bottom(const TiledJet * jet) const {
+    double dphi = jet->phi - phi_min;
+    return dphi*dphi;
+  }
+  double distance_to_top(const TiledJet * jet) const {
+    double dphi = jet->phi - phi_max;
+    return dphi*dphi;
+  }
+
+  double distance_to_left_top(const TiledJet * jet) const {
+    double deta = jet->eta - eta_min;
+    double dphi = jet->phi - phi_max;
+    return deta*deta + dphi*dphi;
+  }
+  double distance_to_left_bottom(const TiledJet * jet) const {
+    double deta = jet->eta - eta_min;
+    double dphi = jet->phi - phi_min;
+    return deta*deta + dphi*dphi;
+  }
+  double distance_to_right_top(const TiledJet * jet) const {
+    double deta = jet->eta - eta_max;
+    double dphi = jet->phi - phi_max;
+    return deta*deta + dphi*dphi;
+  }
+  double distance_to_right_bottom(const TiledJet * jet) const {
+    double deta = jet->eta - eta_max;
+    double dphi = jet->phi - phi_min;
+    return deta*deta + dphi*dphi;
+  }
+
+  
+};
+
+//----------------------------------------------------------------------
+class LazyTiling9Alt {
+public:
+  LazyTiling9Alt(ClusterSequence & cs);
+
+  void run();
+
+  //void get_next_clustering(int & jetA_index, int & jetB_index, double & dij);
+  
+
+protected:
+  ClusterSequence & _cs;
+  const std::vector<PseudoJet> & _jets;
+  std::vector<Tile> _tiles;
+
+
+  double _Rparam, _R2, _invR2;
+  double _tiles_eta_min, _tiles_eta_max;
+  double _tile_size_eta, _tile_size_phi;
+  double _tile_half_size_eta, _tile_half_size_phi;
+  int    _n_tiles_phi,_tiles_ieta_min,_tiles_ieta_max;
+
+  std::vector<TiledJet *> _jets_for_minheap;
+  
+  //MinHeap _minheap;
+
+  void _initialise_tiles();
+
+  // reasonably robust return of tile index given ieta and iphi, in particular
+  // it works even if iphi is negative
+  inline int _tile_index (int ieta, int iphi) const {
+    // note that (-1)%n = -1 so that we have to add _n_tiles_phi
+    // before performing modulo operation
+    return (ieta-_tiles_ieta_min)*_n_tiles_phi
+                  + (iphi+_n_tiles_phi) % _n_tiles_phi;
+  }
+
+  void  _bj_remove_from_tiles(TiledJet * const jet);
+
+  /// returns the tile index given the eta and phi values of a jet
+  int _tile_index(const double eta, const double phi) const;
+
+  // sets up information regarding the tiling of the given jet
+  void _tj_set_jetinfo(TiledJet * const jet, const int _jets_index);
+
+  void _print_tiles(TiledJet * briefjets ) const;
+  void _add_neighbours_to_tile_union(const int tile_index, 
+		 std::vector<int> & tile_union, int & n_near_tiles) const;
+  void _add_untagged_neighbours_to_tile_union(const int tile_index, 
+		 std::vector<int> & tile_union, int & n_near_tiles);
+  void _add_untagged_neighbours_to_tile_union_using_max_info(const TiledJet * const jet, 
+		 std::vector<int> & tile_union, int & n_near_tiles);
+  //double _distance_to_tile(const TiledJet * bj, const Tile *) const;
+  void _update_jetX_jetI_NN(TiledJet * jetX, TiledJet * jetI, std::vector<TiledJet *> & jets_for_minheap);
+
+  void _set_NN(TiledJet * jetI, std::vector<TiledJet *> & jets_for_minheap);
+
+  // return the diJ (multiplied by _R2) for this jet assuming its NN
+  // info is correct
+  template <class J> double _bj_diJ(const J * const jet) const {
+    double kt2 = jet->kt2;
+    if (jet->NN != NULL) {if (jet->NN->kt2 < kt2) {kt2 = jet->NN->kt2;}}
+    return jet->NN_dist * kt2;
+  }
+
+
+  //----------------------------------------------------------------------
+  template <class J> inline void _bj_set_jetinfo(
+                            J * const jetA, const int _jets_index) const {
+    jetA->eta  = _jets[_jets_index].rap();
+    jetA->phi  = _jets[_jets_index].phi_02pi();
+    jetA->kt2  = _cs.jet_scale_for_algorithm(_jets[_jets_index]);
+    jetA->_jets_index = _jets_index;
+    // initialise NN info as well
+    jetA->NN_dist = _R2;
+    jetA->NN      = NULL;
+  }
+
+
+  //----------------------------------------------------------------------
+  template <class J> inline double _bj_dist(
+                const J * const jetA, const J * const jetB) const {
+    double dphi = std::abs(jetA->phi - jetB->phi);
+    double deta = (jetA->eta - jetB->eta);
+    if (dphi > pi) {dphi = twopi - dphi;}
+    return dphi*dphi + deta*deta;
+  }
+
+
+  //----------------------------------------------------------------------
+  template <class J> inline double _bj_dist_not_periodic(
+                const J * const jetA, const J * const jetB) const {
+    double dphi = jetA->phi - jetB->phi;
+    double deta = (jetA->eta - jetB->eta);
+    return dphi*dphi + deta*deta;
+  }
+
+};
+
+
+FASTJET_END_NAMESPACE
+
+#endif // __FASTJET_LAZYTILING9ALT_HH__
Index: external/fastjet/internal/LazyTiling9SeparateGhosts.hh
===================================================================
--- external/fastjet/internal/LazyTiling9SeparateGhosts.hh	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
+++ external/fastjet/internal/LazyTiling9SeparateGhosts.hh	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
@@ -0,0 +1,195 @@
+#ifndef __FASTJET_LAZYTILING9SEPARATEGHOSTS_HH__
+#define __FASTJET_LAZYTILING9SEPARATEGHOSTS_HH__
+
+//FJSTARTHEADER
+// $Id: LazyTiling9SeparateGhosts.hh 3596 2014-08-12 15:27:19Z soyez $
+//
+// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+//
+//----------------------------------------------------------------------
+// This file is part of FastJet.
+//
+//  FastJet is free software; you can redistribute it and/or modify
+//  it under the terms of the GNU General Public License as published by
+//  the Free Software Foundation; either version 2 of the License, or
+//  (at your option) any later version.
+//
+//  The algorithms that underlie FastJet have required considerable
+//  development. They are described in the original FastJet paper,
+//  hep-ph/0512210 and in the manual, arXiv:1111.6097. If you use
+//  FastJet as part of work towards a scientific publication, please
+//  quote the version you use and include a citation to the manual and
+//  optionally also to hep-ph/0512210.
+//
+//  FastJet is distributed in the hope that it will be useful,
+//  but WITHOUT ANY WARRANTY; without even the implied warranty of
+//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+//  GNU General Public License for more details.
+//
+//  You should have received a copy of the GNU General Public License
+//  along with FastJet. If not, see <http://www.gnu.org/licenses/>.
+//----------------------------------------------------------------------
+//FJENDHEADER
+
+//#include "fastjet/PseudoJet.hh"
+#include "fastjet/internal/MinHeap.hh"
+#include "fastjet/ClusterSequence.hh"
+#include "fastjet/internal/LazyTiling9Alt.hh"
+
+FASTJET_BEGIN_NAMESPACE      // defined in fastjet/internal/base.hh
+
+class TiledJet3 {
+public:
+  double     eta, phi, kt2, NN_dist;
+  TiledJet3 * NN, *previous, * next; 
+  int        _jets_index, tile_index;
+  bool _minheap_update_needed;
+  bool is_ghost;
+
+  // indicate whether jets need to have their minheap entries
+  // updated).
+  inline void label_minheap_update_needed() {_minheap_update_needed = true;}
+  inline void label_minheap_update_done()   {_minheap_update_needed = false;}
+  inline bool minheap_update_needed() const {return _minheap_update_needed;}
+};
+
+
+class Tile3 {
+public:
+  /// pointers to neighbouring tiles, including self
+  Tile3 *   begin_tiles[n_tile_neighbours]; 
+  /// neighbouring tiles, excluding self
+  Tile3 **  surrounding_tiles; 
+  /// half of neighbouring tiles, no self
+  Tile3 **  RH_tiles;  
+  /// just beyond end of tiles
+  Tile3 **  end_tiles; 
+  /// start of list of BriefJets contained in this tile
+  TiledJet3 * head;    
+  /// start of list of BriefJets contained in this tile
+  TiledJet3 * ghost_head;    
+  /// sometimes useful to be able to tag a tile
+  bool     tagged;    
+  /// for all particles in the tile, this stores the largest of the
+  /// (squared) nearest-neighbour distances.
+  double max_NN_dist;
+  double eta_centre, phi_centre;
+
+  bool is_near_zero_phi(double tile_size_phi) const {
+    return phi_centre < tile_size_phi || (twopi-phi_centre) < tile_size_phi;
+  }
+};
+
+
+//----------------------------------------------------------------------
+class LazyTiling9SeparateGhosts {
+public:
+  LazyTiling9SeparateGhosts(ClusterSequence & cs);
+
+  void run();
+
+  //void get_next_clustering(int & jetA_index, int & jetB_index, double & dij);
+
+  /// this is the pt2 threshold below which particles will be
+  /// considered as ghosts.
+  ///
+  /// Note that as it stands, a user can decide to change that
+  /// value. Note however that this has to be done at the user's own
+  /// risk (this is an internal part of fastjet).In a similar spirit,
+  /// the interface to access this valus might also change in a future
+  /// release of FastJet.
+  static double ghost_pt2_threshold;
+
+protected:
+  ClusterSequence & _cs;
+  const std::vector<PseudoJet> & _jets;
+  std::vector<Tile3> _tiles;
+
+
+  double _Rparam, _R2, _invR2;
+  double _tiles_eta_min, _tiles_eta_max;
+  double _tile_size_eta, _tile_size_phi;
+  double _tile_half_size_eta, _tile_half_size_phi;
+  int    _n_tiles_phi,_tiles_ieta_min,_tiles_ieta_max;
+
+  std::vector<TiledJet3 *> _jets_for_minheap;
+  
+  //MinHeap _minheap;
+
+  void _initialise_tiles();
+
+  // reasonably robust return of tile index given ieta and iphi, in particular
+  // it works even if iphi is negative
+  inline int _tile_index (int ieta, int iphi) const {
+    // note that (-1)%n = -1 so that we have to add _n_tiles_phi
+    // before performing modulo operation
+    return (ieta-_tiles_ieta_min)*_n_tiles_phi
+                  + (iphi+_n_tiles_phi) % _n_tiles_phi;
+  }
+
+  void  _bj_remove_from_tiles(TiledJet3 * const jet);
+
+  /// returns the tile index given the eta and phi values of a jet
+  int _tile_index(const double eta, const double phi) const;
+
+  // sets up information regarding the tiling of the given jet
+  void _tj_set_jetinfo(TiledJet3 * const jet, const int _jets_index, bool is_ghost);
+
+  void _print_tiles(TiledJet3 * briefjets ) const;
+  void _add_neighbours_to_tile_union(const int tile_index, 
+		 std::vector<int> & tile_union, int & n_near_tiles) const;
+  void _add_untagged_neighbours_to_tile_union(const int tile_index, 
+		 std::vector<int> & tile_union, int & n_near_tiles);
+  void _add_untagged_neighbours_to_tile_union_using_max_info(const TiledJet3 * const jet, 
+		 std::vector<int> & tile_union, int & n_near_tiles);
+  double _distance_to_tile(const TiledJet3 * bj, const Tile3 *) const;
+  void _update_jetX_jetI_NN(TiledJet3 * jetX, TiledJet3 * jetI, std::vector<TiledJet3 *> & jets_for_minheap);
+
+  void _set_NN(TiledJet3 * jetI, std::vector<TiledJet3 *> & jets_for_minheap);
+
+  // return the diJ (multiplied by _R2) for this jet assuming its NN
+  // info is correct
+  template <class J> double _bj_diJ(const J * const jet) const {
+    double kt2 = jet->kt2;
+    if (jet->NN != NULL) {if (jet->NN->kt2 < kt2) {kt2 = jet->NN->kt2;}}
+    return jet->NN_dist * kt2;
+  }
+
+
+  //----------------------------------------------------------------------
+  template <class J> inline void _bj_set_jetinfo(
+                            J * const jetA, const int _jets_index) const {
+    jetA->eta  = _jets[_jets_index].rap();
+    jetA->phi  = _jets[_jets_index].phi_02pi();
+    jetA->kt2  = _cs.jet_scale_for_algorithm(_jets[_jets_index]);
+    jetA->_jets_index = _jets_index;
+    // initialise NN info as well
+    jetA->NN_dist = _R2;
+    jetA->NN      = NULL;
+  }
+
+
+  //----------------------------------------------------------------------
+  template <class J> inline double _bj_dist(
+                const J * const jetA, const J * const jetB) const {
+    double dphi = std::abs(jetA->phi - jetB->phi);
+    double deta = (jetA->eta - jetB->eta);
+    if (dphi > pi) {dphi = twopi - dphi;}
+    return dphi*dphi + deta*deta;
+  }
+
+
+  //----------------------------------------------------------------------
+  template <class J> inline double _bj_dist_not_periodic(
+                const J * const jetA, const J * const jetB) const {
+    double dphi = jetA->phi - jetB->phi;
+    double deta = (jetA->eta - jetB->eta);
+    return dphi*dphi + deta*deta;
+  }
+
+};
+
+
+FASTJET_END_NAMESPACE
+
+#endif // __FASTJET_LAZYTILING9SEPARATEGHOSTS_HH__
Index: external/fastjet/internal/LimitedWarning.hh
===================================================================
--- external/fastjet/internal/LimitedWarning.hh	(revision be6c1c802edfcf2f0bab07b4dfe691afa5010c27)
+++ external/fastjet/internal/LimitedWarning.hh	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
@@ -2,8 +2,8 @@
 #define __FASTJET_INTERNALLIMITEDWARNING_HH__
 
-//STARTHEADER
-// $Id: LimitedWarning.hh 2577 2011-09-13 15:11:38Z salam $
+//FJSTARTHEADER
+// $Id: LimitedWarning.hh 3433 2014-07-23 08:17:03Z salam $
 //
-// Copyright (c) 2005-2011, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
@@ -16,7 +16,9 @@
 //
 //  The algorithms that underlie FastJet have required considerable
-//  development and are described in hep-ph/0512210. If you use
+//  development. They are described in the original FastJet paper,
+//  hep-ph/0512210 and in the manual, arXiv:1111.6097. If you use
 //  FastJet as part of work towards a scientific publication, please
-//  include a citation to the FastJet paper.
+//  quote the version you use and include a citation to the manual and
+//  optionally also to hep-ph/0512210.
 //
 //  FastJet is distributed in the hope that it will be useful,
@@ -28,5 +30,5 @@
 //  along with FastJet. If not, see <http://www.gnu.org/licenses/>.
 //----------------------------------------------------------------------
-//ENDHEADER
+//FJENDHEADER
 
 
Index: external/fastjet/internal/MinHeap.hh
===================================================================
--- external/fastjet/internal/MinHeap.hh	(revision be6c1c802edfcf2f0bab07b4dfe691afa5010c27)
+++ external/fastjet/internal/MinHeap.hh	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
@@ -1,6 +1,6 @@
-//STARTHEADER
-// $Id: MinHeap.hh 2577 2011-09-13 15:11:38Z salam $
+//FJSTARTHEADER
+// $Id: MinHeap.hh 3433 2014-07-23 08:17:03Z salam $
 //
-// Copyright (c) 2005-2011, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
@@ -13,7 +13,9 @@
 //
 //  The algorithms that underlie FastJet have required considerable
-//  development and are described in hep-ph/0512210. If you use
+//  development. They are described in the original FastJet paper,
+//  hep-ph/0512210 and in the manual, arXiv:1111.6097. If you use
 //  FastJet as part of work towards a scientific publication, please
-//  include a citation to the FastJet paper.
+//  quote the version you use and include a citation to the manual and
+//  optionally also to hep-ph/0512210.
 //
 //  FastJet is distributed in the hope that it will be useful,
@@ -25,5 +27,5 @@
 //  along with FastJet. If not, see <http://www.gnu.org/licenses/>.
 //----------------------------------------------------------------------
-//ENDHEADER
+//FJENDHEADER
 
 #ifndef __FASTJET_MINHEAP__HH__
@@ -50,18 +52,26 @@
   /// expansion to a maximum size max_size;
   MinHeap (const std::vector<double> & values, unsigned int max_size) :
-    _heap(max_size) {_initialise(values);};
+    _heap(max_size) {initialise(values);}
+
+  /// do the minimal setup for a MinHeap that can reach max_size;
+  /// initialisation must be performed later with the actual values.
+  MinHeap (unsigned int max_size) : _heap(max_size) {}
 
   /// constructor in which the the maximum size is the size of the values array
   MinHeap (const std::vector<double> & values) :
-    _heap(values.size()) {_initialise(values);};
-  
+    _heap(values.size()) {initialise(values);}
+
+  /// initialise the heap with the supplied values. Should only be called if
+  /// the constructor did not supply values.
+  void initialise(const std::vector<double> & values);
+
   /// return the location of the minimal value on the heap
   inline unsigned int minloc() const {
-    return (_heap[0].minloc) - &(_heap[0]);};
+    return (_heap[0].minloc) - &(_heap[0]);}
   
   /// return the minimal value on the heap
-  inline double       minval() const {return _heap[0].minloc->value;};
+  inline double       minval() const {return _heap[0].minloc->value;}
 
-  inline double operator[](int i) const {return _heap[i].value;};
+  inline double operator[](int i) const {return _heap[i].value;}
 
   /// remove the value at the specified location (i.e. replace it with
@@ -82,5 +92,4 @@
   std::vector<ValueLoc> _heap;
 
-  void _initialise(const std::vector<double> & values);
 
 
Index: external/fastjet/internal/SearchTree.hh
===================================================================
--- external/fastjet/internal/SearchTree.hh	(revision be6c1c802edfcf2f0bab07b4dfe691afa5010c27)
+++ external/fastjet/internal/SearchTree.hh	(revision 35cdc461e095e63247ab9dded070d76bc2c888e2)
@@ -1,6 +1,6 @@
-//STARTHEADER
-// $Id: SearchTree.hh 3107 2013-05-03 15:47:47Z salam $
+//FJSTARTHEADER
+// $Id: SearchTree.hh 3433 2014-07-23 08:17:03Z salam $
 //
-// Copyright (c) 2005-2011, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
@@ -13,7 +13,9 @@
 //
 //  The algorithms that underlie FastJet have required considerable
-//  development and are described in hep-ph/0512210. If you use
+//  development. They are described in the original FastJet paper,
+//  hep-ph/0512210 and in the manual, arXiv:1111.6097. If you use
 //  FastJet as part of work towards a scientific publication, please
-//  include a citation to the FastJet paper.
+//  quote the version you use and include a citation to the manual and
+//  optionally also to hep-ph/0512210.
 //
 //  FastJet is distributed in the hope that it will be useful,
@@ -25,5 +27,5 @@
 //  along with FastJet. If not, see <http://www.gnu.org/licenses/>.
 //----------------------------------------------------------------------
-//ENDHEADER
+//FJENDHEADER
 
 
@@ -188,7 +190,12 @@
 public:
 
-  // so that it can access out _node object;
+  // so that it can access our _node object;
   // note: "class U" needed for clang (v1.1 branches/release_27) compilation
-  template<class U> friend class SearchTree<U>::const_circulator;
+  // 2014-07-22: as reported by Torbjorn Sjostrand,
+  // the next line was giving a warning with Apple LLVM version 5.1 (clang-503.0.40) (based on LLVM 3.4svn)
+  // (dependent nested name specifier 'SearchTree<U>::' for friend class declaration is not supported)
+  // Just commenting it out, things still seem to work; same with a template of type T
+  //template<class U> friend class SearchTree<U>::const_circulator;
+  friend class SearchTree<T>::const_circulator;
   friend class SearchTree<T>;
 
